//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Aqua
#property indicator_color4  Red
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    MA1Period       = 21;
extern int    MA1Method       = MODE_EMA;
extern int    MA1Price        = PRICE_CLOSE;
extern int    MA2Period       = 8;
extern int    MA2Method       = MODE_EMA;
extern bool   ShowMas         = true;
extern bool   ShowArrows      = true;
extern int    arrowSize       = 2;
extern bool   ArrowOnFirstBar = false;

double buffer1[];
double buffer2[];
double upArrow[];
double dnArrow[];
double trend[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,upArrow);
   SetIndexBuffer(3,dnArrow);
   SetIndexBuffer(4,trend);
   
   if (ShowMas)
   {
      SetIndexStyle(0,DRAW_LINE);
      SetIndexStyle(1,DRAW_LINE); 
   }
   else
   {
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
   }
   if (ShowArrows)
   {
      SetIndexStyle(2,DRAW_ARROW,0,arrowSize); SetIndexArrow(2,225);
      SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,226);
   }
   else
   {
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
   }
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0]=limit; return(0); }
                  if (timeFrame!=Period())
                  {
                     int shift = -1; if (ArrowOnFirstBar) shift=1;
                     limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
                        for(int i=limit; i>=0; i--)
                        {
                           int y = iBarShift(NULL,timeFrame,Time[i]);
                           int x = iBarShift(NULL,timeFrame,Time[i+shift]);
                              buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",MA1Period,MA1Method,MA1Price,MA2Period,MA2Method,ShowMas,ShowArrows,arrowSize,0,y);
                              buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"",MA1Period,MA1Method,MA1Price,MA2Period,MA2Method,ShowMas,ShowArrows,arrowSize,1,y);
                              trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",MA1Period,MA1Method,MA1Price,MA2Period,MA2Method,ShowMas,ShowArrows,arrowSize,4,y);
                           if (x!=y)
                           {
                              upArrow[i] = iCustom(NULL,timeFrame,indicatorFileName,"",MA1Period,MA1Method,MA1Price,MA2Period,MA2Method,ShowMas,ShowArrows,arrowSize,2,y);
                              dnArrow[i] = iCustom(NULL,timeFrame,indicatorFileName,"",MA1Period,MA1Method,MA1Price,MA2Period,MA2Method,ShowMas,ShowArrows,arrowSize,3,y);
                           } 
                        }                             
                        return(0);
                   }

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) buffer1[i] = iMA(NULL,0,MA1Period,0,MA1Method,MA1Price,i);
   for(i=limit; i>=0; i--) 
   {
      buffer2[i] = iMAOnArray(buffer1,0,MA2Period,0,MA2Method,i);
      trend[i]   = trend[i+1];
      if (buffer1[i]>buffer2[i]) trend[i] = 1;
      if (buffer1[i]<buffer2[i]) trend[i] =-1;
      
      //
      //
      //
      //
      //
      
      upArrow[i] = EMPTY_VALUE;
      dnArrow[i] = EMPTY_VALUE;
      if (trend[i] != trend[i+1])
      if (trend[i] == 1)
            upArrow[i] = buffer1[i] - iATR(NULL,0,20,i)/2.0;
      else  dnArrow[i] = buffer2[i] + iATR(NULL,0,20,i)/2.0;
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs) {
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}